% This version of the program pins nu down by an endpoint restriction and 
% then finds the values of rho and theta that best fit the data. 

clear all

global income rho theta qdata qmodel price nu sumerr1 sumerr2 nobs

load data                       % Load in data  

[nobs, nser] = size(data);
year     = data(:,1);
price    = data(:,2);
qdata    = data(:,3);
income   = data(:,4);
qmodel   = zeros(nobs,1);
check    = zeros(nobs,1);

%initial guesses
rho = 0.9;
theta = 0.994;
guess = [rho theta]; 

%   Fminsearch
optfmin  = optimset('display', 'iter','TolFun', 1e-12,'TolX', 1e-12, 'MaxFunEvals', 500000);
answer = fminsearch('criteria',guess,optfmin);
rho     = answer(1);  
theta   = answer(2);

%   Call script file to produce results    
results  
    

