% This script file presents the results for the framework

sumerr = criteria(answer);    
rsquared = 1- ( sum((log(qdata(2:nobs)) - log(qmodel(2:nobs))).^2)/sum((log(qdata(2:nobs)) - mean(log(qdata(2:nobs)))).^2) )

%%%%%equivalent variation
c2004  = income(nobs) - price(nobs)*qdata(nobs);
n2004  = qdata(nobs);
Uwcomp = theta*( c2004 )^(1-rho)/(1-rho) ... 
        + (1-theta)*( n2004 + nu)^(1-rho)/(1-rho);
ev = ((1-rho)*Uwcomp-(1-theta)*nu^(1-rho))^(1/(1-rho))/theta^(1/(1-rho))/income(nobs) - 1;

%%%%%compensating variation
optf = optimset('Tolfun',1.e-12,'TolX',1.e-12,'Display','off');
cv = fsolve(@GetCV, 0.2, optf, nu, price(nobs), income(nobs));

%%%%%display results
% format long
fprintf(1,'%s',' sumerr      equivar   compvar    nu        rho        theta');
fprintf(1,'\n');
disp([sumerr,ev, cv ,nu, rho, theta]);

%%%%%figure
figure(1)
plot(year(2:nobs),log(qmodel(2:nobs)),'bo-',year(2:nobs),log(qdata(2:nobs)),'rx:')
title('Computers')
xlabel('Year')
ylabel('Computers')

%year by year welfare gain
%%%%%equivalent variation
consvect = zeros(nobs,1);
nvect = zeros(nobs,1);
Uwcompvect = zeros(nobs,1);
evvect = zeros(nobs,1);
cvvect = zeros(nobs,1);
for i=1:nobs
    consvect(i)  = income(i) - price(i)*qdata(i);
    nvect(i)  = qdata(i);
    Uwcompvect(i) = theta*( consvect(i) )^(1-rho)/(1-rho) ... 
            + (1-theta)*( nvect(i) + nu)^(1-rho)/(1-rho);
    evvect(i) = ((1-rho)* Uwcompvect(i)-(1-theta)*nu^(1-rho))^(1/(1-rho))/theta^(1/(1-rho))/income(i) - 1;

    %%%%%compensating variation
    optf = optimset('Tolfun',1.e-12,'TolX',1.e-12,'Display','off');
    cvvect(i) = fsolve(@GetCV, 0.2, optf, nu, price(i), income(i));
end